// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ZylNMEAGenerator.pas' rev: 6.00

#ifndef ZylNMEAGeneratorHPP
#define ZylNMEAGeneratorHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <SyncObjs.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <IniFiles.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Registry.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Zylnmeagenerator
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TCardinalPoint { cpNorth, cpSouth, cpEast, cpWest };
#pragma option pop

#pragma option push -b-
enum ZylNMEAGenerator__1 { GPGLL, GPGGA, GPVTG, GPRMC, GPGSA, GPGSV, GPZDA, GPWPL, GPRTE, GPAAM, AllNMEA };
#pragma option pop

typedef Set<ZylNMEAGenerator__1, GPGLL, AllNMEA>  TNMEACommands;

class DELPHICLASS TSatellite;
class PASCALIMPLEMENTATION TSatellite : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Word FPseudoRandomCode;
	bool FActive;
	int FAzimuth;
	int FElevation;
	int FSignalToNoiseRatio;
	void __fastcall SetAzimuth(const int Value);
	void __fastcall SetElevation(const int Value);
	void __fastcall SetSignalToNoiseRatio(const int Value);
	
public:
	__property Word PseudoRandomCode = {read=FPseudoRandomCode, nodefault};
	__property bool Active = {read=FActive, write=FActive, nodefault};
	__property int Azimuth = {read=FAzimuth, write=SetAzimuth, nodefault};
	__property int Elevation = {read=FElevation, write=SetElevation, nodefault};
	__property int SignalToNoiseRatio = {read=FSignalToNoiseRatio, write=SetSignalToNoiseRatio, nodefault};
	__fastcall TSatellite(Word p_PseudoRandomCode);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TSatellite(void) { }
	#pragma option pop
	
};


typedef TSatellite* TSatellites[32];

class DELPHICLASS TWayPoint;
class PASCALIMPLEMENTATION TWayPoint : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FName;
	int FLatDeg;
	int FLatMin;
	Extended FLatSec;
	TCardinalPoint FLatDir;
	TCardinalPoint FLongDir;
	int FLongDeg;
	int FLongMin;
	Extended FLongSec;
	void __fastcall SetLatDeg(const int Value);
	void __fastcall SetLatMin(const int Value);
	void __fastcall SetLatSec(const Extended Value);
	void __fastcall SetLatDir(const TCardinalPoint Value);
	void __fastcall SetLongDeg(const int Value);
	void __fastcall SetLongMin(const int Value);
	void __fastcall SetLongSec(const Extended Value);
	void __fastcall SetLongDir(const TCardinalPoint Value);
	
public:
	__fastcall TWayPoint(const AnsiString WayPointName);
	__property AnsiString Name = {read=FName, write=FName};
	__property int Latitude_Degree = {read=FLatDeg, write=SetLatDeg, nodefault};
	__property int Latitude_Minute = {read=FLatMin, write=SetLatMin, nodefault};
	__property Extended Latitude_Second = {read=FLatSec, write=SetLatSec};
	__property TCardinalPoint Latitude_Direction = {read=FLatDir, write=SetLatDir, nodefault};
	__property int Longitude_Degree = {read=FLongDeg, write=SetLongDeg, nodefault};
	__property int Longitude_Minute = {read=FLongMin, write=SetLongMin, nodefault};
	__property Extended Longitude_Second = {read=FLongSec, write=SetLongSec};
	__property TCardinalPoint Longitude_Direction = {read=FLongDir, write=SetLongDir, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TWayPoint(void) { }
	#pragma option pop
	
};


class DELPHICLASS TWayPoints;
class PASCALIMPLEMENTATION TWayPoints : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TWayPoint* operator[](int Index) { return Items[Index]; }
	
private:
	Contnrs::TObjectList* fItems;
	TWayPoint* __fastcall GetItem(int Idx);
	void __fastcall SetItem(int Idx, const TWayPoint* Item);
	int __fastcall GetCount(void);
	
public:
	__property int Count = {read=GetCount, nodefault};
	__property TWayPoint* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	__fastcall TWayPoints(void);
	void __fastcall Dispose(bool DisposeItems);
	HIDESBASE void __fastcall Free(void);
	void __fastcall Add(const TWayPoint* Item);
	void __fastcall Insert(int Idx, const TWayPoint* Item);
	void __fastcall Delete(int Idx, bool DisposeItems)/* overload */;
	void __fastcall Delete(int Idx)/* overload */;
	void __fastcall Delete(const AnsiString WayPointName)/* overload */;
	void __fastcall Delete(const AnsiString WayPointName, bool DisposeItems)/* overload */;
	void __fastcall Clear(bool DisposeItems)/* overload */;
	void __fastcall Clear(void)/* overload */;
	void __fastcall Swap(const AnsiString SourceName, const AnsiString DestinationName);
	int __fastcall IndexOf(const AnsiString WayPointName);
	TWayPoint* __fastcall GetByName(const AnsiString WayPointName);
	void __fastcall SaveToFile(const AnsiString FileName);
	void __fastcall LoadFromFile(const AnsiString FileName);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TWayPoints(void) { }
	#pragma option pop
	
};


class DELPHICLASS TRoute;
class PASCALIMPLEMENTATION TRoute : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FName;
	Classes::TStringList* FWayPoints;
	AnsiString __fastcall GetDestination();
	
public:
	__property AnsiString Name = {read=FName, write=FName};
	__property Classes::TStringList* WayPoints = {read=FWayPoints, write=FWayPoints};
	__property AnsiString Destination = {read=GetDestination};
	__fastcall TRoute(const AnsiString RouteName);
	__fastcall virtual ~TRoute(void);
	void __fastcall SaveToFile(const AnsiString FileName);
	void __fastcall LoadFromFile(const AnsiString FileName);
	AnsiString __fastcall WayPointListToStr();
};


class DELPHICLASS TRoutes;
class PASCALIMPLEMENTATION TRoutes : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TRoute* operator[](int Index) { return Items[Index]; }
	
private:
	Contnrs::TObjectList* fItems;
	TRoute* FActiveRoute;
	TRoute* __fastcall GetItem(int Idx);
	void __fastcall SetItem(int Idx, const TRoute* Item);
	int __fastcall GetCount(void);
	
public:
	__property int Count = {read=GetCount, nodefault};
	__property TRoute* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	__property TRoute* ActiveRoute = {read=FActiveRoute, write=FActiveRoute};
	__fastcall TRoutes(void);
	__fastcall virtual ~TRoutes(void);
	void __fastcall Add(const TRoute* Item);
	void __fastcall Insert(int Idx, const TRoute* Item);
	void __fastcall Delete(int Idx)/* overload */;
	void __fastcall Delete(const AnsiString RouteName)/* overload */;
	void __fastcall Clear(void);
	int __fastcall IndexOf(const AnsiString RouteName);
	void __fastcall Swap(const AnsiString SourceName, const AnsiString DestinationName);
	TRoute* __fastcall GetByName(const AnsiString RouteName);
};


class DELPHICLASS TZylNMEAGenerator;
class PASCALIMPLEMENTATION TZylNMEAGenerator : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FRegistered;
	int FLatDeg;
	int FLatMin;
	Extended FLatSec;
	TCardinalPoint FLatDir;
	TCardinalPoint FLongDir;
	int FLongDeg;
	int FLongMin;
	Extended FLongSec;
	Extended FSpeed;
	Extended FHeading;
	Extended FAltitude;
	Extended FMagnetic_Variation;
	Extended FMagnetic_Heading;
	TCardinalPoint FMagnetic_Variation_Direction;
	Extended FPDOP;
	Extended FHDOP;
	Extended FVDOP;
	Extended FGeo_Height;
	System::TDateTime FUTCDateTime;
	TNMEACommands FCommands;
	TSatellite* FSatellites[32];
	TWayPoints* FWayPoints;
	TRoutes* FRoutes;
	bool FUseSystemDateTime;
	bool FMessageAlert;
	double FVersion;
	AnsiString FCommPort;
	int FBaudRate;
	unsigned ComDevice;
	Syncobjs::TCriticalSection* FCriticalSection;
	double __fastcall RRound(double value);
	AnsiString __fastcall ReplaceDecimalSeparatorEx(const AnsiString s, const AnsiString DS);
	AnsiString __fastcall GetNMEACheckSum(const AnsiString strNMEA);
	AnsiString __fastcall MaxLenStr(const AnsiString s, int MaxLen, char c);
	AnsiString __fastcall MaxLenStrInv(const AnsiString s, int MaxLen, char c);
	AnsiString __fastcall GetUTCDateStr();
	AnsiString __fastcall GetCommaSeparatedUTCDateStr();
	AnsiString __fastcall GetUTCTimeStr();
	System::TDateTime __fastcall GetUTCDateTime(void);
	AnsiString __fastcall GetLatitudeStr();
	AnsiString __fastcall GetLongitudeStr();
	AnsiString __fastcall GetMagneticVariationDirectionStr();
	void __fastcall SetLatDeg(const int Value);
	void __fastcall SetLatMin(const int Value);
	void __fastcall SetLatSec(const Extended Value);
	void __fastcall SetLatDir(const TCardinalPoint Value);
	void __fastcall SetLongDeg(const int Value);
	void __fastcall SetLongMin(const int Value);
	void __fastcall SetLongSec(Extended Value);
	void __fastcall SetLongDir(const TCardinalPoint Value);
	void __fastcall SetHeading(const Extended Value);
	void __fastcall SetMagneticHeading(const Extended Value);
	void __fastcall SetMagneticVariation(const Extended Value);
	void __fastcall SetMagnetic_Variation_Direction(const TCardinalPoint Value);
	void __fastcall SetHDOP(const Extended Value);
	void __fastcall SetVDOP(const Extended Value);
	void __fastcall SetPDOP(const Extended Value);
	Classes::TList* __fastcall GetActiveSatellitesList(void);
	bool __fastcall RunningInTheIDE(void);
	
public:
	__property double Version = {read=FVersion};
	__property TWayPoints* WayPoints = {read=FWayPoints, write=FWayPoints};
	__property TRoutes* Routes = {read=FRoutes, write=FRoutes};
	__fastcall virtual TZylNMEAGenerator(Classes::TComponent* AOwner);
	__fastcall virtual ~TZylNMEAGenerator(void);
	AnsiString __fastcall GetNMEA();
	AnsiString __fastcall GetGPZDA();
	AnsiString __fastcall GetGPGGA();
	AnsiString __fastcall GetGPGLL();
	AnsiString __fastcall GetGPGSA();
	AnsiString __fastcall GetGPRMC();
	AnsiString __fastcall GetGPVTG();
	AnsiString __fastcall GetGPGSV();
	AnsiString __fastcall GetGPWPL();
	AnsiString __fastcall GetGPRTE();
	AnsiString __fastcall GetGPAAM();
	Extended __fastcall GetLatitudeAsDecimalDegrees(void);
	Extended __fastcall GetLongitudeAsDecimalDegrees(void);
	Extended __fastcall KmhToKnots(Extended pSpeed);
	Extended __fastcall KnotsToKmh(Extended pSpeed);
	Extended __fastcall KmToMiles(Extended pDist);
	Extended __fastcall MilesToKm(Extended pDist);
	Extended __fastcall MetersToFeet(Extended pDist);
	Extended __fastcall FeetToMeters(Extended pDist);
	Extended __fastcall DMSToDecimalDegrees(int Degree, int Minute, Extended Second, TCardinalPoint Direction);
	Extended __fastcall DMSToRadians(int Degree, int Minute, Extended Second, TCardinalPoint Direction);
	void __fastcall LatitudeDecimalDegreesToDMS(Extended DecDegree, int &Degree, int &Minute, Extended &Second, TCardinalPoint &Direction);
	void __fastcall LongitudeDecimalDegreesToDMS(Extended DecDegree, int &Degree, int &Minute, Extended &Second, TCardinalPoint &Direction);
	void __fastcall DMSToDM(int dmsDegree, int dmsMinute, Extended dmsSecond, int &Degree, Extended &Minute);
	void __fastcall DMToDMS(int dmDegree, Extended dmMinute, int &Degree, int &Minute, Extended &Second);
	Extended __fastcall KmToNauticalMiles(Extended pDist);
	Extended __fastcall Distance_KM(int Latitude_Degree1, int Latitude_Minute1, Extended Latitude_Second1, TCardinalPoint Latitude_Direction1, int Longitude_Degree1, int Longitude_Minute1, Extended Longitude_Second1, TCardinalPoint Longitude_Direction1, int Latitude_Degree2, int Latitude_Minute2, Extended Latitude_Second2, TCardinalPoint Latitude_Direction2, int Longitude_Degree2, int Longitude_Minute2, Extended Longitude_Second2, TCardinalPoint Longitude_Direction2);
	bool __fastcall Connect(const AnsiString SerialPortName, int BaudRateValue)/* overload */;
	bool __fastcall Connect(const AnsiString SerialPortName)/* overload */;
	bool __fastcall IsConnected(void);
	void __fastcall Disconnect(void);
	unsigned __fastcall Send(AnsiString str);
	void __fastcall SendOnNewThread(AnsiString str);
	unsigned __fastcall Transmit(void);
	void __fastcall TransmitOnNewThread(void);
	AnsiString __fastcall GetSerialPort();
	int __fastcall GetBaudRate(void);
	bool __fastcall SetDCBState(const int BaudRateValue = 0x12c0);
	void __fastcall AddSecondsToLatitude(Extended seconds);
	void __fastcall AddSecondsToLongitude(Extended seconds);
	void __fastcall SetSatellite(Word p_PseudoRandomCode, bool p_Active = true, int p_Elevation = 0x0, int p_Azimuth = 0x0, int p_SignalToNoiseRatio = 0x0);
	Word __fastcall GetActiveSatellitesCount(void);
	Classes::TList* __fastcall GetSatellitesList(void);
	void __fastcall SaveSatellitesToFile(const AnsiString FileName);
	void __fastcall LoadSatellitesFromFile(const AnsiString FileName);
	void __fastcall ResetSatellites(void);
	void __fastcall DrawSatellites(Graphics::TCanvas* Canvas, int Radius, const Graphics::TColor BrushColor, const Graphics::TColor PenColor);
	
__published:
	__property int Latitude_Degree = {read=FLatDeg, write=SetLatDeg, nodefault};
	__property int Latitude_Minute = {read=FLatMin, write=SetLatMin, nodefault};
	__property Extended Latitude_Second = {read=FLatSec, write=SetLatSec};
	__property TCardinalPoint Latitude_Direction = {read=FLatDir, write=SetLatDir, nodefault};
	__property int Longitude_Degree = {read=FLongDeg, write=SetLongDeg, nodefault};
	__property int Longitude_Minute = {read=FLongMin, write=SetLongMin, nodefault};
	__property Extended Longitude_Second = {read=FLongSec, write=SetLongSec};
	__property TCardinalPoint Longitude_Direction = {read=FLongDir, write=SetLongDir, nodefault};
	__property Extended Altitude = {read=FAltitude, write=FAltitude};
	__property Extended Heading = {read=FHeading, write=SetHeading};
	__property Extended Speed = {read=FSpeed, write=FSpeed};
	__property Extended PDOP = {read=FPDOP, write=SetPDOP};
	__property Extended HDOP = {read=FHDOP, write=SetHDOP};
	__property Extended VDOP = {read=FVDOP, write=SetVDOP};
	__property Extended Geo_Height = {read=FGeo_Height, write=FGeo_Height};
	__property Extended Magnetic_Variation = {read=FMagnetic_Variation, write=SetMagneticVariation};
	__property TCardinalPoint Magnetic_Variation_Direction = {read=FMagnetic_Variation_Direction, write=SetMagnetic_Variation_Direction, nodefault};
	__property Extended Magnetic_Heading = {read=FMagnetic_Heading, write=SetMagneticHeading};
	__property System::TDateTime UTCDateTime = {read=FUTCDateTime, write=FUTCDateTime};
	__property TNMEACommands Commands = {read=FCommands, write=FCommands, nodefault};
	__property bool UseSystemDateTime = {read=FUseSystemDateTime, write=FUseSystemDateTime, default=1};
	__property bool MessageAlert = {read=FMessageAlert, write=FMessageAlert, default=1};
};


class DELPHICLASS TSenderThread;
class PASCALIMPLEMENTATION TSenderThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	TZylNMEAGenerator* Owner;
	AnsiString Buffer;
	
protected:
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TSenderThread(TZylNMEAGenerator* AOwner, AnsiString str);
	__fastcall virtual ~TSenderThread(void);
};


class DELPHICLASS EZylNMEAException;
class PASCALIMPLEMENTATION EZylNMEAException : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EZylNMEAException(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EZylNMEAException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EZylNMEAException(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EZylNMEAException(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EZylNMEAException(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EZylNMEAException(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EZylNMEAException(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EZylNMEAException(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EZylNMEAException(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
#define RADIUS_EARTH  (6.378140E+03)
extern PACKAGE void __fastcall Register(void);

}	/* namespace Zylnmeagenerator */
using namespace Zylnmeagenerator;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylNMEAGenerator
